{% extends "viz0/base.html" %}
{% load static %}
{% block title %}{{term.name}} — term{% endblock title %}


{% block content %}
<div id="wrapper" class="narrative">
    <h1>{{montruc}}</h1>
    <h1>{{term.name}}</h1>
    <div class="statement">{{term.statement}}</div>


    <div id="pictos">

    </div>

    {% for item in texts %}
    <div class="text-item">

        {% for p in item.paragraphs %}
        <div class="paragraph">


            <div class="text-content">
                {% for annot in p.annotations %}
                <div class="verse">{{ annot.content }}</div>
                {% endfor %}
            </div>

            <div class="par-terms">
                {% for term, others in p.terms.items %}
                <div class="other-term">
                    {% with strid=term.identifier_str %}
                    {% with illu_url="codex_app/illus/terms/term-"|add:strid|add:".png" %}
                    <a href="{% url 'viz0.get_term' term.id %}">
                        <img title="{{ term.name }}" src="{% static illu_url %}" />
                    </a>
                    {% endwith %}
                    {% endwith %}
                    {% for annot in others %}
                    <div class="side-note">{{ annot.content }}</div>
                    {% endfor %}
                </div>
                {% endfor %}
            </div>
        </div>

        {% endfor %}



    </div>
    {% endfor %}


</div>
{% endblock %}

{% block script %}
const termIlluURL = (id) =>
`{% static "codex_app/illus/terms/" %}term-${id}.png`;

function emptyElement(elem) {
while (elem.firstChild) {
removeElement(elem.firstChild);
}
return elem;
}

function removeElement(elem, keepChildren = false) {
if (!keepChildren) {
emptyElement(elem);
}
const parent = elem.parentNode;
if (parent) {
parent.removeChild(elem);
}
}

const pictos_elem = document.querySelector("#pictos");

const { pictos, incrPictoIndex } = (() => {
const picto_urls = [{% for ia in image_annotations %}"{% url 'codex:get_img_annotation_image' ia.id %}", {% endfor %}];
let index = 0;

const incrPictoIndex = () => {
if (index === picto_urls.length - 1) {
index = 0;
} else {
index += 1;
}
};

const pictos = () => {
if (index === 0) {
return picto_urls;
}
return picto_urls.slice(index).concat(picto_urls.slice(0, index));
};

return { pictos, incrPictoIndex };
})();

const drawImages = () => {
emptyElement(pictos_elem);
pictos()
.map((pictoURL, index, urls) => {
const { width } = pictos_elem.getBoundingClientRect();
const img = document.createElement("img");
const imw = width - (index / urls.length) * width;
const margin = (width - imw) / 2;
img.addEventListener("click", () => {
incrPictoIndex();
setTimeout(drawImages, 1);
});
img.style.position = "absolute";
img.style.width = `${imw}px`;
img.style.height = `auto`;
img.style.left = `${margin}px`;
img.style.bottom = `${margin}px`;
img.setAttribute("src", pictoURL);
return img;
})
.reverse()
.forEach((img) => {
pictos_elem.appendChild(img);
});
};

drawImages();

const sortInterval = (a, b) => a[0] - b[0];

const sortIntervals = (is) => is.sort(sortInterval);

const compileAnnotations = (content, rawIntervals) => {
const start = 0;
const end = content.length;
const intervals = [
...new Set(
sortIntervals(rawIntervals).reduce(
(acc, i) => acc.concat(i[0], i[1]),
[start, end]
)
),
].sort((a, b) => a - b);

const inInterval = (left, right) =>
rawIntervals.filter((a) => a[0] < right && a[1]> left).length > 0;

    const findInterval = (left, right) =>
    rawIntervals.find((a) => a[0] < right && a[1]> left);

        const blocks = [];
        for (let i = 1; i < intervals.length; i +=1) { const int=findInterval(intervals[i - 1], intervals[i]); const
            isCode=int !==undefined; const code=isCode ? int[2] : null; blocks.push({ start: intervals[i - 1], end:
            intervals[i], content: content.slice(intervals[i - 1], intervals[i]), code, }); } return blocks; }; const
            highlightCode=(elem)=> {
            const intervals = JSON.parse(elem.getAttribute("data-intervals"));
            const content = elem.textContent;
            const blocks = compileAnnotations(content, intervals);
            emptyElement(elem);
            blocks.forEach((block) => {
            const className = `block ${block.code !== null ? "code" : ""}`;
            const span = document.createElement("span");
            const text = document.createTextNode(block.content);
            span.setAttribute("class", className);
            span.appendChild(text);
            elem.appendChild(span);

            /*
            if (block.code !== null) {
            const illu = document.createElement('img')
            illu.setAttribute('class', 'term-illu')
            illu.setAttribute('src', termIlluURL(block.code))
            elem.appendChild(illu)
            }
            */
            });
            };



            {% endblock %}